PROGRAM 5: Program to implement operator overloading.


// Program to implement operator overloading.
// This program overloads the + and += operator.

#include<iostream.h>
#include<string.h>

class string
{
 public :
   string(); // a constructor function.
   string (char *);
   ~string();

   string operator+(string const &);
   void operator+=(string const&);
   string(string const&);
   char *disp();

 private:
  char *s;
  int len;
  };

//---------------end of class declarations-------------

  string :: string()  // constructor without parameter
  {
  len=0;
  s=NULL;
  }

  //----------------end of string()----------------

string::string(char *s) // constructor with argument
{
	string::s=new char [strlen(s)+1];
	strcpy(string::s,s);
}
  //----------------end of string(char *s)----------------

string::~string()  //destructor
{
delete [] s;
}
  //----------------end of destructor----------------

string string::operator+(string const &s1)
// function to overload +

{
string temp;
temp.len=s1.len+1+len;
temp.s=new char[temp.len];
strcpy(temp.s,s);
strcat(temp.s,s1.s);
return temp;
}
// end of function operator + overloading

void string::operator +=(string const &s1)
{
char *temp;
temp=new char[len+1];
strcpy(temp,s);
delete[] s;
s=new char[s1.len+strlen(temp)+1];
strcpy(s,temp);
strcpy(s,s1.s);
}
// ----------------end of = operatot overloading

char *string::disp()
{
return s;
}
//----------------------------------------------
string::string (string const &s2)
{
len=s2.len;
s=new char[len+1];
strcpy(s,s2.s);
}
//----------------------------------------------
void main(void)
{
string a1("GIRISH");
string a2(" PANDURANG ");
string a3(" POTDAR ");
string a4;

a4=a1+a2;
cout<<a4.disp()<<endl;
a4+=a3;
cout<<a4.disp();
}

//--------------end of main program---------------------
